/************************************************************************
**
** MiscType.h
**
** Miscilaneous types for C compiler
**
*************************************************************************/

#ifndef MISCTYPE__H
#define MISCTYPE__H

#include <symtab.h>

class enum_value {
	int flag;		//if ture, this was an optional value
	int value;      //this is the value
public:
	enum_value(int val) {flag=1;value=val;}
	enum_value() {flag=0;}
	int isValue(void) {return flag;}
	int GetVal(void){return value;}
};

class abstract {
	link *type;		/*	start of link type chain	*/
	link *etype;	/*	end of link type chain		*/
public:
	abstract(){type=NULL;etype=NULL;}		// constructor
	abstract(int t,int nele,symbol *s){type=NULL;etype=NULL;BuildDeclarator(t,nele,s);}
	void AddDeclarator(link *d);
	link *GetType(void){return type;}
	link *GetEType(void){return etype;}
	abstract *BuildDeclarator(int t,int nele,symbol *s);
	abstract *MergeDeclarator(abstract *a);
};


#endif
