/*-----------------------------------------------------------------**
**                                                                 **
**                        NODE ID's                                **
**                                                                 **
**  ID's of nodes for Abstract Syntax Tree for C Compiler          **
**                                                                 **
**-----------------------------------------------------------------*/

#ifndef NODEIDS__H
#define NODEIDS__H

enum {
	NODEID_EQUALS,		//	'='
	NODEID_MULEQ,       //	'*='
	NODEID_DIVEQ,		//	'/='
	NODEID_MODEQ,		//	'%='
	NODEID_ADDEQ,		//	'+='
	NODEID_SUBEQ,       //	'-='
	NODEID_SHLEQ,		//	'<<='
	NODEID_SHREQ,       //	'>>='
	NODEID_ANDEQ,		//	'&='
	NODEID_OREQ,		//	'|='
	NODEID_XOREQ,		//	'^='
	NODEID_QUESTION,	//	'?'':'
	NODEID_OR,			//	'||'
	NODEID_AND,			//	'&&'
	NODEID_BITOR,		//	'|'
	NODEID_BITXOR,		//	'^'
	NODEID_BITAND,		//	'&'
	NODEID_EQ,			//	'=='
	NODEID_NE,			//	'!='
	NODEID_LT,			//	'<'
	NODEID_GT,			//	'>'
	NODEID_LE,			//	'<='
	NODEID_GE,			//	'>='
	NODEID_SHL,			//	'<<'
	NODEID_SHR,			//	'>>'
	NODEID_ADD,			//	'+'
	NODEID_SUB,			//	'-'
	NODEID_MUL,			//	'*'
	NODEID_DIV,			//	'/'
	NODEID_MOD,			//	'%'
	NODEID_CAST,
	NODEID_PREINC,
	NODEID_PREDEC,
	NODEID_COMPLEMENT,
	NODEID_ADDRESS_OF,
	NODEID_CONTENT_OF,
	NODEID_POSITIVE,
	NODEID_NEGATIVE,
	NODEID_NOT,
	NODEID_SIZEOF,
	NODEID_ARRAY,
	NODEID_MEMBER,
	NODEID_FUNCCALL,
	NODEID_PTR_TO,
	NODEID_POSTINC,
	NODEID_POSTDEC,
	NODEID_SUBSCRIPT,
	NODEID_ARGUMENTS,
	NODEID_CONSTANT,
	NODEID_IDENT,
	NODEID_STRING,
	NODEID_COMMA,
	NODEID_LABEL,
	NODEID_CASE,
	NODEID_DEFAULT,
	NODEID_FOR,
	NODEID_DO,
	NODEID_WHILE,
	NODEID_SWITCH,
	NODEID_IF,
	NODEID_IFELSE,
	NODEID_RETURN,
	NODEID_BREAK,
	NODEID_CONTINUE,
	NODEID_GOTO,
	NODEID_EXP,
	NODEID_NULL,
	NODEID_CONSTANT_EXP,
	NODEID_IFPART,
	NODEID_ELSEPART
};

#endif	//NODEIDS__H